using System;

namespace Chat.Controlador
{
	public enum TipusAccio
	{
		Entrar, Sortir, NouMissatge, CrearCanal, EsborrarCanal, ObtenirCanals, ObtenirUsuarisCanal
	}

	/// <summary>
	/// Descripcin breve de ChatAccio.
	/// </summary>
	public class ChatClientCommand
	{
		private TipusAccio accio;
		private string nick;
		private string missatge;
		private string canal;

		public TipusAccio Accio 
		{
			get 
			{
				return accio;
			}
			set 
			{
				accio = value;
			}
		}

		public string Nick 
		{
			get 
			{
				return nick;
			}
			set 
			{
				nick = value;
			}
		}

		public string Missatge
		{
			get 
			{
				return missatge;
			}
			set 
			{
				missatge = value;
			}
		}

		public string Canal
		{
			get 
			{
				return canal;
			}
			set 
			{
				canal = value;
			}
		}

		public ChatClientCommand(TipusAccio accio)
		{
			this.accio = accio;
		}
		public ChatClientCommand(TipusAccio accio, string nick, string canal)
		{
			this.accio = accio;
			this.nick = nick;
			this.canal = canal;
		}
		public ChatClientCommand(TipusAccio accio, string nick, string missatge, string canal)
		{
			this.accio = accio;
			this.nick = nick;
			this.missatge = missatge;
			this.canal = canal;
		}
	}
}
