using System;
using System.Collections;

namespace Chat.Controlador
{
	/// <summary>
	/// Descripcin breve de ChatFacade.
	/// </summary>
	public class ChatClientFacade
	{
		private IChatClient chat;

		public ChatClientFacade(IChatFactory chatFactory)
		{
			this.chat = chatFactory.crearChatClient();
		}

		public ArrayList sendCommand(ChatClientCommand command)
		{
			ArrayList resultat = null;
			switch(command.Accio)
			{
				case TipusAccio.CrearCanal:
					chat.crearCanal(command.Canal);
					break;

				case TipusAccio.EsborrarCanal:
					chat.esborrarCanal(command.Canal);
					break;

				case TipusAccio.Entrar:
					chat.entrar(command.Nick, command.Canal);
					break;

				case TipusAccio.Sortir:
					chat.sortir(command.Nick, command.Canal);
					break;

				case TipusAccio.NouMissatge:
					chat.enviarMissatge(command.Nick, command.Canal, command.Missatge);
					break;

				case TipusAccio.ObtenirCanals:
					resultat = chat.getCanals();
					break;

				case TipusAccio.ObtenirUsuarisCanal:
					resultat = chat.getUsuarisCanal(command.Canal);
					break;

				default:
					break;
			}
			return resultat;
		}
	}
}
