using System;
using System.Collections;

namespace Chat.Model
{
	/// <summary>
	/// Descripcin breve de DadesServidor.
	/// </summary>
	public class DadesServidor : IDadesServidor
	{
		private static bool instanciat = false;
		private static DadesServidor instancia;
		private Hashtable canals;


		public DadesServidor()
		{
			this.canals = new Hashtable();
		}

		public static DadesServidor getInstance()
		{	
			if(! instanciat)
			{
				instancia = new DadesServidor();
				instanciat = true;
			}
			return instancia;
		}

		public void crearCanal(string nom)
		{
			canals.Add(nom, new DadesCanal(nom));
		}

		public void esborrarCanal(string nom)
		{
			canals.Remove(nom);
		}

		public ArrayList getCanalsActuals()
		{
			ArrayList nomsCanalsActuals = new ArrayList();
			foreach (DictionaryEntry entrada in canals) 
			{
				DadesCanal dc = (DadesCanal)entrada.Value;
				nomsCanalsActuals.Add(dc.Nom);
			}
			return nomsCanalsActuals;
		}

		public void afegirUsuariCanal(string nick, string nom_canal)
		{
			DadesCanal canal = (DadesCanal)canals[nom_canal];
			if (canal != null) 
			{
				canal.afegirUsuari(nick);
			} 
			else 
			{
				// Error
				throw new Exception("El canal no existeix");
			}
		}

		public void esborrarUsuariCanal(string nick, string nom_canal)
		{
			DadesCanal canal = (DadesCanal)canals[nom_canal];
			if (canal != null) 
			{
				canal.esborrarUsuari(nick);
			} 
			else 
			{
				// Error
				throw new Exception("El canal no existeix");
			}
		}

		public ArrayList getUsuarisCanal(string nom_canal)
		{
			DadesCanal canal = (DadesCanal)canals[nom_canal];
			if (canal != null) 
			{
				return canal.getUsuaris();
			} 
			else 
			{
				// Error
				return null;
			}
		}

		public bool existeixUsuariCanal (string nick, string nom_canal)
		{
			DadesCanal canal = (DadesCanal)canals[nom_canal];
			if (canal != null) 
			{
				return canal.existeixUsuari(nick);
			} 
			else 
			{
				// Error
				return false;
			}
		}

		public bool existeixCanal (string nom_canal)
		{
			DadesCanal canal = (DadesCanal)canals[nom_canal];
			if (canal == null) 
			{
				return false;
			} 
			else 
			{
				return true;
			}
		}
	}
}
