using System;
using System.Runtime.Remoting;
using Chat.Controlador;

namespace Chat.Remoting
{
	/// <summary>
	/// Descripcin breve de ChatListeners.
	/// </summary>
	public class ChatListeners : RemotelyDelegatableObject
	{
		IChatListeners listeners;

		public ChatListeners(IChatListeners listeners) 
		{
			this.listeners = listeners;
		}

		protected override void InternalEntrarCallback (object sender, ChatEventArgs chatEventInfo)
		{
			listeners.entrar(chatEventInfo.Canal, chatEventInfo.Nick);
		}

		protected override void InternalSortirCallback (object sender, ChatEventArgs chatEventInfo)
		{
			listeners.sortir(chatEventInfo.Canal, chatEventInfo.Nick);
		}

		protected override void InternalNouMissatgeCallback (object sender, ChatEventArgs chatEventInfo)
		{
			listeners.nouMissatge(chatEventInfo.Canal,chatEventInfo.Nick,chatEventInfo.Missatge);
		}

		protected override void InternalCrearCanalCallback (object sender, ChatEventArgs chatEventInfo)
		{
			listeners.afegirCanal(chatEventInfo.Canal);
		}

		protected override void InternalEsborrarCanalCallback (object sender, ChatEventArgs chatEventInfo)
		{
			listeners.esborrarCanal(chatEventInfo.Canal);
		}
	}
}
