
using System;
using System.Runtime.Remoting;

namespace Chat.Remoting
{

	public abstract class RemotelyDelegatableObject : MarshalByRefObject
	{
		public void EntrarCallback (object sender, ChatEventArgs chatEventInfo)
		{
			InternalEntrarCallback (sender, chatEventInfo);		
		}

		public void SortirCallBack (object sender, ChatEventArgs chatEventInfo)
		{
			InternalSortirCallback (sender, chatEventInfo);		
		}

		public void NouMissatgeCallback (object sender, ChatEventArgs chatEventInfo)
		{
			InternalNouMissatgeCallback (sender, chatEventInfo);		
		}

		public void CrearCanalCallback (object sender, ChatEventArgs chatEventInfo)
		{
			InternalCrearCanalCallback (sender, chatEventInfo);
		}
		
		public void EsborrarCanalCallback (object sender, ChatEventArgs chatEventInfo)
		{
			InternalEsborrarCanalCallback (sender, chatEventInfo);
		}

		protected abstract void InternalEntrarCallback (object sender, ChatEventArgs chatEventInfo);
		protected abstract void InternalSortirCallback (object sender, ChatEventArgs chatEventInfo);
		protected abstract void InternalNouMissatgeCallback (object sender, ChatEventArgs chatEventInfo);
		protected abstract void InternalCrearCanalCallback (object sender, ChatEventArgs chatEventInfo);
		protected abstract void InternalEsborrarCanalCallback (object sender, ChatEventArgs chatEventInfo);
	}
}


