using System;
using System.Collections;
using System.Runtime.Remoting;
using Chat.Controlador;


namespace Chat.Remoting
{
	/// <summary>
	/// Descripcin breve de RemotingChatClient.
	/// </summary>
	public class RemotingChatClient : IChatClient
	{
		private RemotingChat chat;
		private ChatListeners listeners;

		public RemotingChatClient(string fitxerConfig, IChatListeners listeners)
		{
			RemotingConfiguration.Configure(fitxerConfig);
			chat = RemotingChat.getInstance();

			this.listeners = new ChatListeners(listeners);
			
			chat.CrearCanalEvent += new CrearCanalEventHandler(this.listeners.CrearCanalCallback);
			chat.EntrarEvent += new EntrarEventHandler(this.listeners.EntrarCallback);
			chat.EsborrarCanalEvent += new EsborrarCanalEventHandler(this.listeners.EsborrarCanalCallback);
			chat.MissatgeEvent += new MissatgeEventHandler(this.listeners.NouMissatgeCallback);
			chat.SortirEvent += new SortirEventHandler(this.listeners.SortirCallBack);
		}

		public void crearCanal(string nom_canal) {
			chat.crearCanal(nom_canal);
		}
		public void esborrarCanal(string nom_canal) {
			chat.esborrarCanal(nom_canal);
		}
		public ArrayList getCanals() {
			return chat.getCanals();
		}
		public ArrayList getUsuarisCanal(string nom_canal) {
			return chat.getUsuarisCanal(nom_canal);
		}
		public bool entrar(string nick, string nom_canal) {
			return chat.entrar(nick, nom_canal);
		}
		public bool sortir(string nick, string nom_canal) {
			return chat.sortir(nick, nom_canal);
		}
		public bool enviarMissatge(string nick, string nom_canal, string missatge) {
			return chat.enviarMissatge(nick, nom_canal, missatge);
		}
	}
}
