using System;
using System.Reflection;
using System.IO;
using Chat.Controlador;

namespace Chat.Remoting
{
	/// <summary>
	/// Descripcin breve de ChatFactory.
	/// </summary>
	public class RemotingChatFactory : IChatFactory
	{
		String fitxerConfig;
		IChatListeners listeners;

		public RemotingChatFactory(string fitxerConfig, IChatListeners listeners)
		{
			this.fitxerConfig = fitxerConfig;
			this.listeners = listeners;
		}

		public IChatClient crearChatClient()
		{
			return new RemotingChatClient(fitxerConfig, listeners);
		}

		public IChatServer crearChatServer()
		{
			return new RemotingChatServer(fitxerConfig);
		}

	}
}
