using System;

namespace Chat.VistaClient
{
	public delegate void CrearCanalEventHandler(object sender, ChatEventArgs args);
	public delegate void EsborrarCanalEventHandler(object sender, ChatEventArgs args);
	public delegate void EntrarEventHandler(object sender, ChatEventArgs args);
	public delegate void SortirEventHandler(object sender, ChatEventArgs args);
	public delegate void MissatgeEventHandler(object sender, ChatEventArgs args);

	/// <summary>
	/// Descripcin breve de ChatSubject.
	/// </summary>
	public class ChatSubject
	{
		static bool instanciat = false;
		static ChatSubject instancia;

		public event EntrarEventHandler EntrarEvent;
		public event SortirEventHandler SortirEvent;
		public event MissatgeEventHandler MissatgeEvent;
		public event CrearCanalEventHandler CrearCanalEvent;
		public event EsborrarCanalEventHandler EsborrarCanalEvent;

		private ChatSubject(){}
		public static ChatSubject getInstancia() 
		{
			if (!instanciat) 
			{
				instancia = new ChatSubject();
				instanciat = true;
			}
			return instancia;
		}

		public void entrarEvent(ChatEventArgs args) 
		{
			if (EntrarEvent != null) 
			{
				EntrarEvent(this, args);
			}
		}

		public void sortirEvent(ChatEventArgs args) 
		{
			if (SortirEvent != null) 
			{
				SortirEvent(this, args);
			}
		}

		public void missatgeEvent(ChatEventArgs args) 
		{
			if (MissatgeEvent != null) 
			{
				MissatgeEvent(this, args);
			}
		}

		public void crearCanalEvent(ChatEventArgs args) 
		{
			if (CrearCanalEvent != null) 
			{
				CrearCanalEvent(this, args);
			}
		}

		public void esborrarCanalEvent(ChatEventArgs args) 
		{
			if (EsborrarCanalEvent != null) 
			{
				EsborrarCanalEvent(this, args);
			}
		}
	}
}
