using System;
using System.Windows.Forms;
using Chat.Controlador;

namespace Chat.VistaClient
{
	/// <summary>
	/// Descripcin breve de VistaListeners.
	/// </summary>
	public class VistaListeners : IChatListeners
	{
		ChatSubject chatSubject;

		public VistaListeners()
		{
			chatSubject = ChatSubject.getInstancia();
		}

		public void entrar(string nom_canal, string nick) 
		{
			chatSubject.entrarEvent(new ChatEventArgs(nick, nom_canal));
		}
		public void sortir(string nom_canal, string nick) {
			chatSubject.sortirEvent(new ChatEventArgs(nick, nom_canal));
		}
		public void nouMissatge(string nom_canal, string nick, string missatge) {
			chatSubject.missatgeEvent(new ChatEventArgs(nick, missatge, nom_canal));
		}
		public void afegirCanal(string nom_canal) {
			chatSubject.crearCanalEvent(new ChatEventArgs(nom_canal));
		}
		public void esborrarCanal(string nom_canal) {
			chatSubject.esborrarCanalEvent(new ChatEventArgs(nom_canal));
		}
	}
}
