using System;

namespace Chat.VistaClient
{
	/// <summary>
	/// Descripcin breve de VistaObserver.
	/// </summary>
	public class VistaObserver
	{
		private ChatSubject chatSubject;
		private FormVistaClient window;
		private string nick;
		private string canal;

		public string Nick 
		{
			get 
			{
				return nick;
			}
			set 
			{
				nick = value;
			}
		}

		public string Canal 
		{
			get 
			{
				return canal;
			}
			set 
			{
				canal = value;
			}
		}

		public VistaObserver(FormVistaClient window)
		{
			chatSubject = ChatSubject.getInstancia();
			this.window = window;
			this.nick = "";
			this.canal = "";

			chatSubject.CrearCanalEvent += new CrearCanalEventHandler(this.crearCanal);
			chatSubject.EntrarEvent += new EntrarEventHandler(this.entrar);
			chatSubject.EsborrarCanalEvent += new EsborrarCanalEventHandler(this.esborrarCanal);
			chatSubject.MissatgeEvent += new MissatgeEventHandler(this.nouMissatge);
			chatSubject.SortirEvent += new SortirEventHandler(this.sortir);
		}

		public void entrar (object sender, ChatEventArgs chatEventInfo)
		{
			if (canal.CompareTo(chatEventInfo.Canal) == 0) 
			{
				if (nick.CompareTo(chatEventInfo.Nick) != 0) 
				{
					window.afegirUsuari(chatEventInfo.Nick);
					window.escriureMissatge(chatEventInfo.Nick + " -> entra al canal.");
				}
			}
		}

		public void sortir (object sender, ChatEventArgs chatEventInfo)
		{
			if (canal.CompareTo(chatEventInfo.Canal) == 0) 
			{
				if (nick.CompareTo(chatEventInfo.Nick) != 0) 
				{
					window.esborrarUsuari(chatEventInfo.Nick);
					window.escriureMissatge(chatEventInfo.Nick + " -> surt del canal.");
				}
			}
		}

		public void nouMissatge (object sender, ChatEventArgs chatEventInfo)
		{
			if (canal.CompareTo(chatEventInfo.Canal) == 0) 
			{
				window.escriureMissatge(chatEventInfo.Nick + ": " + chatEventInfo.Missatge);
			}
		}

		public void crearCanal (object sender, ChatEventArgs chatEventInfo)
		{
			window.afegirCanal(chatEventInfo.Canal);
		}

		public void esborrarCanal (object sender, ChatEventArgs chatEventInfo)
		{
			window.esborrarCanal(chatEventInfo.Canal);
		}

	}
}
